##### Activity
# Technology Usability Review
Inquiry Activity

## Learning Objectives:
- [LO 1.2.5] Analyze the correctness, usability, functionality, and suitability of computational artifacts. [P4]
- [LO 7.1.1] Explain how computing innovations affect communication, interaction, and cognition. [P4]


## What is usability?

In this unit, students are learning to think about and view technology differently than they have before. While examining technology and the creativity behind it, they must also remember that a big factor of technology is its usability. The population of technology users includes people of all backgrounds, ages, and technological comfort levels.

In 1990, Dr. Jakob Nielsen wrote his “10 Usability Heuristics for User Interface Design”. Though written nearly 30 years ago, the principles outlined in that article provide a baseline for the elements needed to create a usable software product. By reading the article and analyzing a website or app with the 10 heuristics, students will have the opportunity to look at software differently and to practice verbalizing their thoughts on the ways in which computing affects people and their actions.

### What you need:
A link to the 10 Usability Heuristics for students to visit on their own. If students cannot access the link electronically, you can create handouts: https://www.nngroup.com/articles/ten-usability-heuristics/

Give the students two minutes to think of a website or app that they use frequently. Have them silently write down the site or app with one or two sentences saying why they like using it. Then point the students to the 10 Usability Heuristics. Provide about 10 minutes for the class to read the article, then give students the opportunity to ask clarification questions about the heuristics. Encourage the students to answer each other's questions.

Once the students are all comfortable with the content in the article, they should return to the website or app they identified earlier and analyze it with the usability heuristics. Instruct the students to put their analysis in writing and to ensure that their analysis addresses all ten of the heuristics. Students should be sure to say how the site or app fulfills each heuristic. If it does not fulfill a heuristic, students should mention that and suggest a way in which they could fulfill it.


### Discussion Questions:
- Why are usability heuristics such as these important when designing websites and apps?
- Do you agree with the ten usability heuristics chosen here? Would you add others? Take any away?
- Should the heuristics change based on the device you’re using? The intent of the site or app? The cultural and social norms of its users?

### Assessment Questions:
- What is the purpose of the website you looked at? LO [1.2.5]
- Does it have weaknesses, mistakes or errors that detract from its purpose? LO [1.2.5]
- What is something that is easy to do using this website? What about something hard? LO [1.2.5]
