#### Table of Contents
* [Overview of AP CS Principles Create Task](#overview-of-ap-cs-principles-create-task)
* ["Using Game Development 1 as Practice"](#using-game-development-1-as-practice)
  * ["Days 1-3"](#days-1-3)
    * ["Document the Process"](#document-the-process)
    * ["Brainstorming"](#brainstorming)
  * ["Day 4 - Iterating"](#day-4-iterating)
    * ["Design"](#design)
    * ["Implement"](#implement)
    * ["Test"](#test)
    * ["Repeat"](#repeat)
  * ["AP CS Principles Practice: Written Responses"](#ap-cs-principles-practice-written-responses)
* ["What's Next"](#what-s-next)

# Overview of AP CS Principles Create Task

Programming is a creative process that brings ideas to life. Programs can help solve problems, enable innovations, or express personal interests. For the Create Performance Task, students will develop a program of their choice, in a programming language of their choice.

CodeCombat's Computer Science (CS) courses teach programming through a series of puzzles (levels) the students solve with code. Designing and implementing an original creative program requires a different approach than solving a specific, given problem - and that's where CodeCombat's Game Development (GD) and Web Development (WD) courses shine: each course leads up to a final project, where the student creates her own original work. These projects serve as a great opportunity to practice for the AP CSP Create Task, which requires the student to submit a program of their own creation, either to solve a problem they're interested in, or as a creative expression. (Learning Objectives 5.1.1 and 5.1.2)

By playing CodeCombat's Game and Web Development courses, students will gain valuable practice in applying the iterative "design - implement - test" process, creating their own abstractions and algorithms, and collaborating with peers as co-creators and play testers. Multiple practice opportunities throughout CodeCombat’s AP CS Principles syllabus will allow students to focus on various components of the Create task. This guide focuses on the first of those practice opportunities in Game Development 1.

Side note: Students may choose to develop their final project within CodeCombat, or they may use another programming environment that they're familiar with.

**AP CS Principles Create Task Requirements**

Summary of the [“Create” Performance Task for AP CS Principles (See Page 79)](https://www.google.com/url?q=https://secure-media.collegeboard.org/digitalServices/pdf/ap/ap-computer-science-principles-course-and-exam-description.pdf&sa=D&ust=1502495268157000&usg=AFQjCNHXeen0QXYWUvwHkrH6wF1D5yL73Q):

* 24% of the final score.
* Minimum of 12 class hours for the final project.
* Submission Deadline: April 30

Components to the Create Task:

* Iterative process to create a program:
  * Design
  * Implement
  * Test
* Independently create at least one of each:
  * Algorithm
  * Abstraction
* Create a video that displays the running of their program and demonstrates its functionality.
* Write responses to questions about their program.
* Submit their entire program code to the AP Digital Portfolio.

Refer to the [AP CS Principles Course Description](https://www.google.com/url?q=https://secure-media.collegeboard.org/digitalServices/pdf/ap/ap-computer-science-principles-course-and-exam-description.pdf&sa=D&ust=1502495268160000&usg=AFQjCNFD_DeH8O_v3hPqaGlsVFfeBgSkMw) for the following:

* Teacher Overview of Performance Task: Create (page 79)
* Student Handout for Performance Task: Create (page 113)

**CodeCombat Create Task Practice Opportunities**

<a id="t.9a8106a5bd908eba5d08c136ecaf1af3b83ae6bf"></a><a id="t.0"></a>

<table class="c38">

<tbody>

<tr class="c3">

<td class="c25" colspan="1" rowspan="1">

</td>

<td class="c12" colspan="1" rowspan="1">

Game Dev 1

</td>

<td class="c9" colspan="1" rowspan="1">

Game Dev 2

</td>

<td class="c9" colspan="1" rowspan="1">

Game Dev 3

</td>

</tr>

<tr class="c3">

<td class="c25" colspan="1" rowspan="1">

Create

</td>

<td class="c12" colspan="1" rowspan="1">

</td>

<td class="c9" colspan="1" rowspan="1">

</td>

<td class="c9" colspan="1" rowspan="1">

</td>

</tr>

<tr class="c3">

<td class="c25" colspan="1" rowspan="1">

Iterative Process

</td>

<td class="c12" colspan="1" rowspan="1">

Yes

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

</tr>

<tr class="c3">

<td class="c25" colspan="1" rowspan="1">

---- Design

</td>

<td class="c12" colspan="1" rowspan="1">

Yes

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

</tr>

<tr class="c3">

<td class="c25" colspan="1" rowspan="1">

---- Implement

</td>

<td class="c12" colspan="1" rowspan="1">

Yes

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

</tr>

<tr class="c3">

<td class="c25" colspan="1" rowspan="1">

---- Test

</td>

<td class="c12" colspan="1" rowspan="1">

Yes

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

</tr>

<tr class="c3">

<td class="c25" colspan="1" rowspan="1">

Code Requirements

</td>

<td class="c12" colspan="1" rowspan="1">

</td>

<td class="c9" colspan="1" rowspan="1">

</td>

<td class="c9" colspan="1" rowspan="1">

</td>

</tr>

<tr class="c3">

<td class="c25" colspan="1" rowspan="1">

---- Algorithms

</td>

<td class="c12" colspan="1" rowspan="1">

--

</td>

<td class="c9" colspan="1" rowspan="1">

--

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

</tr>

<tr class="c3">

<td class="c25" colspan="1" rowspan="1">

---- Abstractions

</td>

<td class="c12" colspan="1" rowspan="1">

--

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

</tr>

<tr class="c3">

<td class="c25" colspan="1" rowspan="1">

Capture Video

</td>

<td class="c12" colspan="1" rowspan="1">

--

</td>

<td class="c9" colspan="1" rowspan="1">

--

</td>

<td class="c9" colspan="1" rowspan="1">

--

</td>

</tr>

<tr class="c3">

<td class="c25" colspan="1" rowspan="1">

Written Responses

</td>

<td class="c12" colspan="1" rowspan="1">

Yes

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

<td class="c9" colspan="1" rowspan="1">

Yes

</td>

</tr>

<tr class="c3">

<td class="c25" colspan="1" rowspan="1">

Submit to AP Portfolio

</td>

<td class="c12" colspan="1" rowspan="1">

--

</td>

<td class="c9" colspan="1" rowspan="1">

--

</td>

<td class="c9" colspan="1" rowspan="1">

--

</td>

</tr>

</tbody>

</table>

# Using Game Development 1 as Practice

Learning Objectives covered in Game Development 1:

*   5.1.1 Develop a program for creative expression, to satisfy personal curiosity, or to create new knowledge.
*   5.1.2 Develop a correct program to solve problems.

When teaching the Game Dev 1 course for AP CSP students, you should focus on :

*   Brainstorming for Ideas
*   The Process of Game Design
*   Journaling about the Process
*   The Value of Collaboration

Since the students' knowledge of programming is very basic at this level, they will have limited ability to practice the Abstractions or Algorithm components of the Create task in Game Development 1.Those will be better covered in Game Dev 2 and beyond.

The [Game Development 1 5-Day Project Guide](https://codecombat.com/teachers/resources/gd1-5day) introduces the basic concepts of game design as the students play through the course. By guiding the students through this process, you help them develop the mental framework they need to think creatively about designing and implementing their own games, which they'll put into practice in the course's final project level.

## Days 1-3

Days 1 through 3 focus on teaching students how to build a game in CodeCombat using **pieces**, **mechanics**, and **goals**.

The levels the students play will teach the implementation details, but it's important for you to guide the discussion around the levels. Let the students know up front that, they'll soon be designing their own game, and they'll need to use the techniques and concepts they're learning when they make their own games.

Refer to the [Game Development 1 Project Guide](https://www.google.com/url?q=https://codecombat.com/teachers/resources/gd1-5day&sa=D&ust=1502495268183000&usg=AFQjCNHFplfQxgH_Ol54QbNUC1swq4Nhog) for level-by-level tips and discussion questions.

### Document the Process

Keeping a list of the pieces, mechanics, and goals in their journals will not only help the students remember all of the tools they have available when creating their own games, but show them how to document their Game Dev journey. Taking good notes will make the design process easier, and help them remember the challenges they overcame while making their project - and that'll make answering the written questions at the end easier.

For the Create Performance Task, students will need to provide written or audio responses to specific questions. As practice for the final Create submission, students should answer the following questions in their journal as they design their game:

*   Identify the programming language used.
*   Identify the purpose of their program.
*   Describe the incremental and iterative development process of their program.
*   Describe the difficulties and/or opportunities encountered, and how they were resolved.
*   Clearly indicate whether the development described was collaborative or independent.

### Brainstorming

At the end of Day 3, help the students get started brainstorming ideas for their course 1 projects. Encourage them to find creative combinations of the tools they've learned to make new types of games! During the course, they saw ideas for some basic games, but those are just the beginning… let the students experiment with combining the pieces, mechanics, and goals in new ways.

Starting with Brainstorming, and continuing throughout the Iterative Design Process, the students should collaborate with each other, particularly if they are stuck.

## Day 4 - Iterating

Day 4 is where the bulk of the Iterative Design Process happens:

1.  Design
2.  Implement
3.  Test
4.  Repeat

### Design

Design is the process of taking the student's idea, and turning it into a concrete plan. Each student should write a brief description of her idea, and then describe it in terms of the pieces, mechanics, and goals they'll use to make it happen. Encourage them to draw a rough map of what they imagine the game will look like, and how the player will interact with the game.

Students should answer the following questions in their journal as they design their game:

1.  What is the purpose or idea behind the game?
2.  What are the player's goals?
3.  What pieces will be used?
4.  What are the core mechanics used?
5.  What programming language will be used?
6.  Did you collaborate with anyone while designing your game? What was their contribution?

### Implement

Now that the student has a design for their game, it's time to implement!

This is the process of creating the code that makes the game real. Students should use the Tabula Rasa level to create this Game Dev 1 practice project. Remind the students to document any difficulties they run into, and how they were able to work around those problems. In the final project, they'll need to answer questions about challenges they overcame, so this is a good opportunity to get some practice taking good notes.

If the student collaborates with others during the Implementation phase, they should be sure to clearly mark any code they use that they did not independently create, and where it came from.

Students should answer the following in their journal as they implement their game:

1.  What difficulties did you encounter while implementing your game?
2.  How did you resolve the difficulties?
3.  What new ideas or opportunities arose while implementing your game?
4.  How did you decide to use, or discard, those new ideas?
5.  Did you collaborate with anyone while implementing your game? What was their contribution?

### Test

Testing is a great opportunity to practice collaboration! First, students should play each others' games. The creator of the game should simply observe the player, and take notes of anything surprising - did the player interact with the game as intended? Did they try something completely unexpected? Did they find a bug? What part of the game did they seem to enjoy? What part seemed to frustrate them?

Then, ask for feedback from the player. Ask some of the same kinds of questions - what they liked, what was frustrating.

Encourage the students not to get frustrated if they run into problems -- all great games had problems at first! It's only through testing and iteration that their favorite games became so good. Problems that turn up during testing are road signs showing students the way to make their game even better.

Students should answer the following questions in their journal as they test their game:

1.  Who tested your game?
2.  What bugs did your playtesters discover while testing your game?
3.  Did the players interact with your game in surprising, or unintended ways?
4.  How can you use the information gained from testing to make your game better?

### Repeat

Iteration means to repeat the process several times, each time making adjustments and improvements. Now, armed with feedback from playtesters, the students should go back to design solutions to any problems, then implement them, and test the new version of the game!

Students should answer the following questions in their journal while iterating on their game:

1.  How will you resolve the issues uncovered during this iteration of your game? What will you change, and why?

## AP CS Principles Practice: Written Responses

A major component of the AP CS Principles Create task are the written responses students will provide regarding their computational artifact. Game Development 1 offers students a chance to practice answering a subset of those questions, which are reproduced below and can also be found in the Performance Task: Create – Applications from Ideas section of the student handout materials.

Since students will likely not have captured video for their Game Development 1 project, they can simply provide a written response for 2a.

> **Program Purpose and Development**
>
> 2a. Provide a written response or audio narration in your video that:
>
> \- identifies the programming language;
>
> \- identifies the purpose of your program; and explains what the video illustrates.
> <br/>*(Must not exceed 150 words)*
> <br/><br/>
> 2b. Describe the incremental and iterative development process of your program, focusing on two distinct points in that process. Describe the difficulties and/ or opportunities you encountered and how they were resolved or incorporated.
> <br/><br/>
> In your description clearly indicate whether the development described was collaborative or independent. At least one of these points must refer to independent program development.
> <br/>*(Must not exceed 200 words)*

Teachers can refer to the [scoring guidelines for the Create task](https://www.google.com/url?q=https://secure-media.collegeboard.org/digitalServices/pdf/ap/create-sample-tasks-sg.pdf&sa=D&ust=1502495268196000&usg=AFQjCNHJz9fdMXEo3PsZBhqsuNDyvwULfQ) to grade students’ responses to the above prompts. Here are specific areas to point out, based on the College Board’s scoring rubric and provided examples:

*   2a. Make sure the student explains exactly what their game does and identifies the pieces, mechanics and goals. For the purposes of this practice opportunity, the “goal” of their game is the “purpose” of their program.
*   2b. Make sure the student describes two different times in their development that they made major decisions during the iterative process. They should also describe who they worked with and what collaboration took place.

# What's Next

Students need to complete the Computer Science 2 course before advancing on to Game Development 2\. In CS2 they'll learn more skills they need for the AP CSP Create task, including use of mathematical and logical concepts to develop abstractions.

